unit NpsPort;
{
*************** Freeware Freeware Freeware ********************************
*	Name:					NpsPort.PAS																								*
*	Description:	Port Component and functuons (Byte and Word)							*
*	Platform:			Delphi 2.0/3.0																						*
*	Files:				NpsPort.dcr	- component resource file											*
*								NpsPort.pas	- component source 														*
*	Author:				Anatoly Podgoretsky																				*
*								Vahe 4-31, Johvi, Estonia, EE2045													*
*								kvk@estpak.ee																							*
*	Installation:	Copy all files into source directory (NpsPort)						*
*								Then install on palette, component installed on AddOn tab.*
*								If this tab not good for you simple change tab in					*
*								register procedure, look comment in code									*
*	Editor:				Tabs step = 2, Courier New																*
*	Started:			23.08.97 - v.1.0  Initial release													*
*								Properties Address and Value															*
*	Modivied:			20.12.97 - v.1.01 now as in old Delphi time - Port array	*
*													 Property Port (Indexed), other removed					*
*								26.12.97 - v.1.02 Port and PortW now default property			*
***************************************************************************
*	Copyright:		() NPS, 1997																							*
***************************************************************************
*	This programm fully free and may use and distribute as you want, except	*
* Copyright notice, this must stay unchanged. Of couse if you modify			*
* programm you may add yours Portion Copyright statement below us. Also		*
* state our names in a credits section of your program and use it as you	*
* like. For your own risk	of course as you go in uncontrolled territory		*
* Also this can not work under NT because NT do not allow direct access		*
* to hardware. May be future version of Windows also desable it too				*
* For example construction like:																					*
*     while (Port[$1F7] and $80) <> 0 do;																	*
* work under DOS but not under Windos95																		*
***************************************************************************
* Remarks and Exampes																											*
* Put TNpsPortB or TNpsPortW component on form and get descriptive name,	*
* for examole ComPort																											*
* In code use next syntax:																								*
*   Value := ComPort.Port[$3F8); for reading byte from Com1 port					*
*   ComPort.Port[$3F8) := Value; for writing byte into port								*
* use appriciated Byte or Word component. Thats all												*
* if you assign name as Port or PortW then above example may look like		*
*   Value				:= Port[$3F8); for reading byte from Com1 port						*
*   Port[$3F8)	:= Value; for writing byte into port											*
*   Value				:= PortW[Adr); for word port															*
*   PortW[Adr)	:= Value; for writing word into port											*
* If You still remember old Pascal style, do you see difference?					*
***************************************************************************
* For high speed needs you may use non component function and procedures	*
*   functions 	PortReadByte, PortReadWord, PortReadWordLS 								*
*  	procedures	PortWriteByte, PortWriteWord, PortWriteWordLS							*
* PortXxxLS applicable for old computers if problem with word operations	*
***************************************************************************
}
interface

uses
  Windows,
  Classes;
type
	TNpsPortB = class(TComponent)
		private
      function	GetPort(Adr:Word) : Byte;
      procedure	SetPort(Adr:Word; AValue:Byte);
    public
    	constructor Create(AOwner:TComponent);	override;
    	property	Port[Adr:word]	: Byte read	GetPort write SetPort; default;
	end;	// TNpsPortB

		{Word Port class}

	TNpsPortW = class(TComponent)
		private
      function	GetPort(Adr:Word) : Word;
      procedure	SetPort(Adr:Word; AValue:Word);
    public
    	constructor Create(AOwner:TComponent);	override;
    	property	PortW[Adr:word]	: Word read	GetPort write SetPort; default;
	end;	// TNpsPortW

	procedure Register;

	function PortReadByte(Addr:Word)	 : Byte;
	function PortReadWord(Addr:Word)	 : Word;
	function PortReadWordLS(Addr:Word) : Word;
	procedure PortWriteByte(Addr:Word; Value:Byte);
	procedure PortWriteWord(Addr:Word; Value:Word);
	procedure PortWriteWordLS(Addr:Word; Value:Word);

implementation

{********************
 * Create component	*
 ********************}
constructor TNpsPortB.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
end;	// Create

constructor TNpsPortW.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
end;	// Create
{**************
 * Get Value	*
 **************}
function	TNpsPortB.GetPort(Adr:Word) : Byte;
begin
	Result := PortReadByte(Adr);
end;

function	TNpsPortW.GetPort(Adr:Word) : Word;
begin
	Result := PortReadWord(Adr);
end;
{**************
 * Set Value	*
 **************}
procedure	TNpsPortB.SetPort(Adr:Word; AValue:Byte);
begin
  PortWriteByte(Adr,AValue);
end;	// Click

procedure	TNpsPortW.SetPort(Adr:Word; AValue:Word);
begin
  PortWriteWord(Adr,AValue);
end;	// Click
{**********************************************************************
 * Component registration, change section name for you favorite AddOn	*
 **********************************************************************}
procedure Register;
begin
  RegisterComponents('AddOn',[TNpsPortB]);
  RegisterComponents('AddOn',[TNpsPortW]);
end;	// Register

////////////////////////////////////////////////////////
// procedures and functions for maximall speed access //
// not members of class																//
////////////////////////////////////////////////////////

const
	Delay = 150;				// dalay between two bytes operation
  										// depending of CPU speed and cards speed
{****************************************************************
 * Port Read byte function																			*
 * Parameter: port address		 																	*
 * Return: 		byte value from given port 												*
 ****************************************************************}
function PortReadByte(Addr:Word) : Byte; assembler; register;
asm
	MOV	DX,AX
  IN	AL,DX
end;
{****************************************************************
 * HIGH SPEED Port Read Word function														*
 * Parameter: port address		 																	*
 * Return:	 	word value from given port 												*
 * Comment: 	may problem with some cards and computers					*
 *						that can't to access whole word, usualy it work.	*
 ****************************************************************}
function PortReadWord(Addr:Word) : Word; assembler; register;
asm
	MOV	DX,AX
  IN	AX,DX
end;
{****************************************************************
 * LOW SPEED Port Read Word function														*
 * Parameter: port address		 																	*
 * Return:	 	word value from given port 												*
 * Comment: 	work in all cases, only to adjust DELAY if need		*
 ****************************************************************}
function PortReadWordLS(Addr:Word) : Word; assembler; register;
asm
	MOV		DX,AX
  IN		AL,DX			// read LSB port
	MOV		ECX,Delay
@1:
	LOOP	@1				// delay between two reads
	XCHG	AH,AL
  INC		DX				// port+1
	IN		AL,DX			// read MSB port
	XCHG	AH,AL			// restore bytes order
end;
{****************************************************************
 * Port Write byte function																			*
 * Parameter: port address		 																	*
 ****************************************************************}
procedure PortWriteByte(Addr:Word; Value:Byte); assembler; register;
asm
	XCHG	AX,DX
	OUT		DX,AL
end;
{****************************************************************
 * HIGH SPEED Port Write word procedure													*
 * Comment: 	may problem with some cards and computers					*
 *						that can't to access whole word, usualy it work.	*
 ****************************************************************}
procedure PortWriteWord(Addr:word; Value:word); assembler; register;
asm
	XCHG	AX,DX
	OUT		DX,AX
end;
{****************************************************************
 * LOW SPEED Port Write Word procedure													*
 * Parameter: port address		 																	*
 * Return:	 	word value from given port 												*
 * Comment: 	work in all cases, only to adjust DELAY if need		*
 ****************************************************************}
procedure PortWriteWordLS(Addr:word; Value:word); assembler; register;
asm
	XCHG	AX,DX
	OUT		DX,AL			// port LSB
	MOV		ECX,Delay
@1:
	LOOP	@1				// delay between two writes
	XCHG	AH,AL
  INC		DX				// port+1
	OUT		DX,AL			// port MSB
end;

end.
